#include <windows.h>
#include <commctrl.h>
#include "filter.h"
#include "resource.h"
#define MIN_H 38
#define WIN_H 70
#define WIN_W 320
#define ID_CFG 2001
#pragma resource "tatami.RES"
#ifndef ListView_SetCheckState
#define ListView_SetCheckState(hwndLV, i, fCheck) ListView_SetItemState(hwndLV, i, \
INDEXTOSTATEIMAGEMASK((fCheck)+1), LVIS_STATEIMAGEMASK)
#endif
static LPRECT lpRect=NULL;
static int *show=NULL;
static int *lock=NULL;
static int n=0;
static FILTER *fpg;
//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
FILTER_DLL filter = {
	FILTER_FLAG_DISP_FILTER|FILTER_FLAG_WINDOW_SIZE|FILTER_FLAG_ALWAYS_ACTIVE|FILTER_FLAG_PRIORITY_LOWEST|FILTER_FLAG_EX_INFORMATION,
	WIN_W,WIN_H,
	"܂肽",
	NULL,NULL,NULL,
	NULL,NULL,
	NULL,NULL,NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	func_WndProc,
	NULL,NULL,
	NULL,
	NULL,
	"܂肽 version 0.02",
	NULL,
	NULL,
};
BOOL isActive(HWND hwnd)
{
	WINDOWINFO wi;
	GetWindowInfo(hwnd,&wi);
	return wi.dwWindowStatus;
}
int tatami_init(FILTER *fp,void *editp){
	SYS_INFO si;
	int i;
	FILTER *cfp;
	TCHAR buf[32];
	if(!(fp->exfunc->get_sys_info(editp,&si))) return FALSE;
	n=si.filter_n;
	if((show=(int *)malloc(sizeof(int)*n))==NULL) return FALSE;
	if((lpRect=(LPRECT)malloc(sizeof(RECT)*n))==NULL) return FALSE;
	if((lock=(int *)malloc(sizeof(int)*64))==NULL) return FALSE;
	for(i=0;i<n;i++){
		*(show+i)=TRUE;
		cfp=(FILTER *)fp->exfunc->get_filterp(i);
		if(cfp==NULL)
			continue;
		*(lock+i)=fp->exfunc->ini_load_int(fp,cfp->name,0);
		ZeroMemory(lpRect+i,sizeof(RECT));
		GetWindowRect(cfp->hwnd,lpRect+i);
	}
	return TRUE;
}
void tatami(HWND check,FILTER *fp)
{
	int i,w,h;
	FILTER *cfp;
	if(BST_CHECKED == SendMessage(check , BM_GETCHECK , 0 , 0)){ //`FbNĂ鎞̏
		for(i=0;i<n;i++){
			cfp=(FILTER *)(fp->exfunc->get_filterp(i));
			if(cfp==NULL)
				continue;
			if(*(show+i)==TRUE){ //݂̃EChETCY擾
				GetWindowRect(cfp->hwnd,lpRect+i);
			}
			
			w=(lpRect+i)->right-(lpRect+i)->left;
			if(*(show+i)&&fp->exfunc->is_filter_window_disp(cfp)&&!isActive(cfp->hwnd)&&!(*(lock+i))){ //܂肽
				h=MIN_H;
				SetWindowPos(cfp->hwnd,NULL,0,0,w,h,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOREPOSITION|SWP_NOSENDCHANGING|SWP_NOZORDER);
				*(show+i)=FALSE;
			}
			if(!(*(show+i))&&isActive(cfp->hwnd)){ //ɖ߂
				h=(lpRect+i)->bottom-(lpRect+i)->top;
				SetWindowPos(cfp->hwnd,NULL,0,0,w,h,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOREPOSITION|SWP_NOSENDCHANGING|SWP_NOZORDER);
				*(show+i)=TRUE;
			}
			
		}
	}
	else{ //`FbNꂽƂ̏
		for(i=0;i<n;i++){
			cfp=(FILTER *)fp->exfunc->get_filterp(i);
			if(cfp==NULL)
				continue;
			w=(lpRect+i)->right-(lpRect+i)->left;
			if(!*(show+i)){
				h=(lpRect+i)->bottom-(lpRect+i)->top;
				SetWindowPos(cfp->hwnd,NULL,0,0,w,h,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOREPOSITION|SWP_NOSENDCHANGING|SWP_NOZORDER);
				*(show+i)=TRUE;
			}
		}
	}
}


void createList(HWND hDlgWnd)
{
	int i;
	LV_COLUMN col;
	LV_ITEM item;
	HWND hList=GetDlgItem(hDlgWnd,IDC_LIST1);
	FILTER *cfp;
	DWORD dwStyle;
	dwStyle = ListView_GetExtendedListViewStyle(hList);
	dwStyle |= LVS_EX_CHECKBOXES|LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES;
	ListView_SetExtendedListViewStyle(hList, dwStyle);
	col.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	col.fmt = LVCFMT_LEFT;
	col.cx = 170;
	col.pszText = "vOC";
	col.iSubItem = 0;
	ListView_InsertColumn(hList, 0, &col);
	col.cx = 90;
	col.iSubItem = 1;
	col.pszText = "\/\";
	ListView_InsertColumn(hList, 1, &col);
	memset(&item, 0, sizeof(LV_ITEM));
	item.mask = LVIF_TEXT;
	for(i=0;i<n;i++){
		if((cfp=(FILTER *)fpg->exfunc->get_filterp(i))==NULL)
			continue;
		item.iItem = i;
		
		item.iSubItem = 0;
		item.pszText = cfp->name;
		ListView_InsertItem(hList, &item);
		item.iSubItem= 1;
		if(fpg->exfunc->is_filter_window_disp(cfp))
			item.pszText = "\";
		else
			item.pszText = "\";
		ListView_SetItem(hList,&item);
		ListView_SetCheckState(hList,i,*(lock+i));
	}
	
}

//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}

LRESULT CALLBACK CfgDlgProc(HWND hDlgWnd, UINT message, WPARAM wparam, LPARAM lparam)
{
	int i;
	FILTER *cfp;
	HWND hList=GetDlgItem(hDlgWnd,IDC_LIST1);
    switch (message) {
        case WM_INITDIALOG:
            createList(hDlgWnd);
        	break;
        case WM_COMMAND:
            switch (LOWORD(wparam)) {
                case IDOK:
                	for(i=0;i<n;i++){
                		if(ListView_GetCheckState(hList,i))
                			*(lock+i)=1;
                		else
                			*(lock+i)=0;
                	}
                    EndDialog(hDlgWnd, IDOK);
                    break;
                case IDCANCEL:
                    EndDialog(hDlgWnd, IDCANCEL);
                    break;
                default:
                    return FALSE;
            }
        default:
            return FALSE;
    }
    return TRUE;
}

//---------------------------------------------------------------------
//		WndProc
//---------------------------------------------------------------------
BOOL func_WndProc( HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam,void *editp,FILTER *fp )
{
	static int ini=0,error=0;
	int i,cfg;
	static HWND check,config;
	SYS_INFO si;
	FILTER *cfp;
	TCHAR buf[256];
	if(error==1) return FALSE;
	switch(message) {
		case WM_WINDOWPOSCHANGING:
		case WM_CAPTURECHANGED:
			if(ini==1&&(BST_CHECKED==SendMessage(check,BM_GETCHECK,0,0)))
				tatami(check,fp);
			break;
		case WM_COMMAND:
			if(ini==0){
				if(BST_CHECKED==SendMessage(check , BM_GETCHECK , 0 , 0)||(LOWORD(wparam))==ID_CFG){
					ini=1;
					if(tatami_init(fp,editp)==FALSE){
						error=1;
						MessageBox(hwnd , TEXT("G[") ,TEXT("Error") , MB_OK);
						return FALSE;
					}
				}
				else
					break;
			}
			switch(LOWORD(wparam)) {
				case ID_CFG:
					fpg=fp;
					cfg=DialogBox(fp->dll_hinst, "CONFIG_DIALOG", hwnd, (DLGPROC)CfgDlgProc);
					if(cfg)
						tatami(check,fp);
					break;
				default:
					tatami(check,fp);
					break;
			}
			break;
		case WM_FILTER_INIT:
			InitCommonControls();
			check=CreateWindow(
			TEXT("BUTTON") , TEXT("") ,
			WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX | BS_LEFTTEXT ,
			0 , 0 , 314 , 16 ,
			hwnd , NULL , fp->dll_hinst , NULL
			);
			config=CreateWindow(
			TEXT("BUTTON") ,TEXT("ݒ") ,
			WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
			250,20,60,24,
			hwnd,(HMENU)ID_CFG,fp->dll_hinst,NULL);
			if(fp->exfunc->get_sys_info(editp,&si)){
    			SendMessage(check, WM_SETFONT, (WPARAM)si.hfont, (LPARAM)true);
    			SendMessage(config, WM_SETFONT, (WPARAM)si.hfont, (LPARAM)true);
    		}
			SendMessage(check , BM_SETCHECK , BST_UNCHECKED , 0);
			break;
		case WM_FILTER_EXIT:
			SendMessage(check , BM_SETCHECK , BST_UNCHECKED , 0);
			tatami(check,fp);
			for(i=0;i<n;i++)
				if((cfp=(FILTER *)(fp->exfunc->get_filterp(i)))!=NULL)
					fp->exfunc->ini_save_int(fp,cfp->name,*(lock+i));

			free(show);
			free(lpRect);
			free(lock);
	}
	return FALSE;
}
